
DEFINE STREAM stmInput.

/*-- scheduler printers ---*/
FILE-INFO:FILE-NAME = SESSION:TEMP-DIRECTORY + "sp-printers.txt".
IF FILE-INFO:FULL-PATHNAME <> ?
THEN DO TRANSACTION ON ERROR UNDO, LEAVE: 
  FOR EACH aa-edi-control WHERE
           aa-edi-control.controlkode BEGINS "PRINTER-"
           EXCLUSIVE-LOCK :
     DELETE aa-edi-control.
  END.

  INPUT STREAM stmInput FROM VALUE(SESSION:TEMP-DIRECTORY + "sp-printers.txt").
  REPEAT:
    CREATE aa-edi-control.
    IMPORT STREAM stmInput DELIMITER ";" aa-edi-control.
  END. /* REPEAT */
  INPUT STREAM stmInput CLOSE.
END. /* DO */
