/* Nieuwe sequence vullen voor oude records. */

DEF VAR iSeqNr AS INT NO-UNDO.
DEF VAR cTmp   AS CHAR NO-UNDO.

FOR EACH sp-company NO-LOCK ,
  EACH aa-fin_paymode 
    WHERE aa-fin_paymode.companycode EQ sp-company.companycode
  EXCLUSIVE
  BY aa-fin_paymode.paymode_seqnr DESCENDING : /* LL: anders infinite loop */
  
  ASSIGN cTmp = "aa-fin_paymode":U.
  /* ***************************  Main Block  *************************** */


/*   {system/include/sp-seq.i &value    = next
                         &seq-code = cTmp
                         &initial-values = "sp-sequence.current_value = 47"
                         &veld     = iSeqNr
                         &create_if_not_exist = YES }
 */
DO:
  zoek:
  DO WHILE TRUE:

    IF NOT CAN-FIND(sp-sequence WHERE
         sp-sequence.sequencecode = cTmp )
    THEN DO:
     
        CREATE sp-sequence.
        ASSIGN sp-sequence.sequencecode = cTmp
               sp-sequence.current_value = 47.
     
    END.

    FIND sp-sequence WHERE
         sp-sequence.sequencecode = cTmp
         EXCLUSIVE-LOCK.
    
      ASSIGN iSeqNr = (IF sp-sequence.current_value <> ?
                              THEN sp-sequence.current_value
                              ELSE sp-sequence.initial_value).
      
      ASSIGN sp-sequence.previous_value = iSeqNr
                                          
             sp-sequence.current_value  = (IF (ABS(sp-sequence.previous_value)
                                             + ABS(sp-sequence.interval)) <=
                                               ABS(sp-sequence.limit) 
                                           THEN (sp-sequence.previous_value
                                               + sp-sequence.interval)
                                           ELSE (IF sp-sequence.cycle_at_limit
                                                 THEN sp-sequence.initial_value
                                                 ELSE ?)).

    LEAVE zoek.

  END. /* zoek: DO WHILE TRUE */

  RELEASE sp-sequence.
  
END.


 

  ASSIGN
    aa-fin_paymode.paymode_seqnr = iSeqNr
    aa-fin_paymode.file_path     = sp-company.fin_account-filepath
    aa-fin_paymode.file_prefix   = (IF aa-fin_paymode.paymodecode = "CLIEOP"
                                    THEN "CLIEOP03" 
                                    ELSE "BTL91")
    .
  
END.

/* Attatchement sequences uitdelen, voor bestaande purchase invoices. */
FOR EACH aa-purchase_invoice
  EXCLUSIVE-LOCK :
  
  ASSIGN 
    aa-purchase_invoice.attachmentnr = NEXT-VALUE(aa-attachment).
  
END.

