DEF VAR iTel AS INT NO-UNDO.

FOR EACH aa-tp_file WHERE 
         aa-tp_file.companycode = "EUC" 
     AND aa-tp_file.acc_year    = 0 
     AND aa-tp_file.vesselnr    <> 0 EXCLUSIVE-LOCK:

    FIND aa-vessel WHERE 
         aa-vessel.companycode = "EUC"
     AND aa-vessel.vesselnr = aa-tp_file.vesselnr NO-LOCK NO-ERROR.

    IF AVAIL aa-vessel 
    THEN DO:
      ASSIGN aa-tp_file.acc_year = aa-vessel.acc_year
             aa-tp_file.acc_period = aa-vessel.acc_period
             iTel = iTel + 1.
    END.
END.

MESSAGE iTel "files done.".
