DEF VAR cProgram                      AS CHARACTER NO-UNDO.
DEF VAR cAction                       AS CHARACTER NO-UNDO.
DEF VAR cTable                        AS CHARACTER NO-UNDO.
DEF VAR iTotal                        AS INTEGER   NO-UNDO.
DEF VAR iDone                         AS INTEGER   NO-UNDO.

{System/conversion/conversion_progress.i}


DEFINE VARIABLE cCode                 AS CHARACTER      NO-UNDO.
DEFINE VARIABLE cLijst                AS CHARACTER      NO-UNDO.

DEFINE BUFFER b-aa-edi-control    FOR aa-edi-control.

ASSIGN
  cProgram  = THIS-PROCEDURE:FILE-NAME
  cAction   = "Scheduler suppress warnings"
  iTotal    = 0
  iDone     = 0
  cTable    = "Scheduler"
  .

FIND b-aa-edi-control WHERE
     b-aa-edi-control.controlkode = "SuppressWarnings"
  NO-LOCK NO-ERROR.

IF AVAILABLE b-aa-edi-control AND b-aa-edi-control.lijst <> ""
THEN cLijst = b-aa-edi-control.lijst.
ELSE cLijst = "yes".

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

FOR EACH aa-edi-scheduler
  NO-LOCK:

  cCode = "SuppressWarnings-" + aa-edi-scheduler.schedulerid_code.

  FIND b-aa-edi-control WHERE
       b-aa-edi-control.controlkode = cCode
    NO-LOCK NO-ERROR.

  IF NOT AVAILABLE b-aa-edi-control
  THEN DO:
    CREATE b-aa-edi-control.
    ASSIGN
      b-aa-edi-control.controlkode = cCode
      b-aa-edi-control.lijst       = cLijst
      .
  END.

  iDone = iDone + 1.
  RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

END.

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).


